Index: branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90
===================================================================
--- branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 3317)
+++ branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 3318)
@@ -4,6 +4,6 @@
    !! Ocean passive tracers:  correction of negative concentrations
    !!======================================================================
-   !! History :   -   !  01-01  (O. Aumont & E. Kestenare)  Original code
-   !!            1.0  !  04-03  (C. Ethe)  free form F90
+   !! History :  OPA  !  2001-01  (O. Aumont & E. Kestenare)  Original code
+   !!   NEMO     1.0  !  2004-03  (C. Ethe)  free form F90
    !!----------------------------------------------------------------------
 #if defined key_top
@@ -11,16 +11,16 @@
    !!   'key_top'                                                TOP models
    !!----------------------------------------------------------------------
-   !!   trc_rad    : correction of negative concentrations
-   !!----------------------------------------------------------------------
-   USE oce_trc             ! ocean dynamics and tracers variables
-   USE trc                 ! ocean passive tracers variables
-   USE trdmod_oce
-   USE trdtra
-   USE prtctl_trc          ! Print control for debbuging
+   !!   trc_rad       : correction of negative concentrations
+   !!----------------------------------------------------------------------
+   USE oce_trc        ! ocean dynamics and tracers variables
+   USE trc            ! ocean passive tracers variables
+   USE trd_oce        ! trends: ocean variables
+   USE trdtra         ! trends: tracer manager
+   USE prtctl_trc     ! Print control for debbuging
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC trc_rad         ! routine called by trcstp.F90
+   PUBLIC   trc_rad   ! routine called by trcstp.F90
 
    !! * Substitutions
@@ -31,5 +31,4 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-   
 CONTAINS
 
@@ -49,5 +48,6 @@
       !!                (the total CFC content is not strictly preserved)
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index      
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
+      !
       CHARACTER (len=22) :: charout
       !!----------------------------------------------------------------------
@@ -77,4 +77,5 @@
       !
    END SUBROUTINE trc_rad
+
 
    SUBROUTINE trc_rad_sms( kt, ptrb, ptrn, jp_sms0, jp_sms1, cpreserv )
@@ -94,35 +95,26 @@
       !!                  (the total content of concentration is not strictly preserved)
       !!--------------------------------------------------------------------------------
-      !! Arguments
-      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
-      INTEGER  , INTENT( in ) ::  &
-         jp_sms0, &       !: First index of the passive tracer model
-         jp_sms1          !: Last  index of  the passive tracer model
-
-      REAL(wp), DIMENSION (jpi,jpj,jpk,jptra), INTENT( inout )  :: &
-         ptrb, ptrn       !: before and now traceur concentration
-
-      CHARACTER( len = 1) , INTENT(in), OPTIONAL  :: &
-         cpreserv          !: flag to preserve content or not
-      
-      ! Local declarations
-      INTEGER  :: ji, jj, jk, jn     ! dummy loop indices
-      REAL(wp) :: ztrcorb, ztrmasb   ! temporary scalars
-      REAL(wp) :: zcoef, ztrcorn, ztrmasn   !    "         "
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztrtrdb, ztrtrdn   ! workspace arrays
-      REAL(wp) :: zs2rdt
-      LOGICAL ::   lldebug = .FALSE.
-      !!----------------------------------------------------------------------
-
+      INTEGER                                , INTENT(in   ) ::   kt                 ! ocean time-step index
+      INTEGER                                , INTENT(in   ) ::   jp_sms0, jp_sms1   ! first/last index of the passive tracer model
+      REAL(wp), DIMENSION (jpi,jpj,jpk,jptra), INTENT(inout) ::   ptrb, ptrn         ! before/now traceur concentration
+      CHARACTER( len = 1),      OPTIONAL     , INTENT(in   ) ::   cpreserv           ! flag to preserve content or not
+      !
+      INTEGER  ::   ji, jj, jk, jn             ! dummy loop indices
+      REAL(wp) ::   ztrcorb, ztrmasb, zs2rdt   ! local scalars
+      REAL(wp) ::   zcoef, ztrcorn, ztrmasn    !   -      -
+      LOGICAL  ::   lldebug = .FALSE.
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztrtrdb, ztrtrdn   ! 3D workspace
+      !!----------------------------------------------------------------------
  
       IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrtrdb, ztrtrdn )
       
       IF( PRESENT( cpreserv )  ) THEN   !  total tracer concentration is preserved 
-      
+         !                                                           ! ===========
+
          DO jn = jp_sms0, jp_sms1
-            !                                                        ! ===========
-            ztrcorb = 0.e0   ;   ztrmasb = 0.e0
-            ztrcorn = 0.e0   ;   ztrmasn = 0.e0
-
+            !
+            ztrcorb = 0._wp   ;   ztrmasb = 0._wp
+            ztrcorn = 0._wp   ;   ztrmasn = 0._wp
+            !
             IF( l_trdtrc ) THEN
                ztrtrdb(:,:,:) = ptrb(:,:,:,jn)                        ! save input trb for trend computation
@@ -132,8 +124,7 @@
             ztrcorb = glob_sum( MIN( 0., ptrb(:,:,:,jn) ) * cvol(:,:,:) )
             ztrcorn = glob_sum( MIN( 0., ptrn(:,:,:,jn) ) * cvol(:,:,:) )
-
             ztrmasb = glob_sum( MAX( 0., ptrb(:,:,:,jn) ) * cvol(:,:,:) )
             ztrmasn = glob_sum( MAX( 0., ptrn(:,:,:,jn) ) * cvol(:,:,:) )
-
+            !
             IF( ztrcorb /= 0 ) THEN
                zcoef = 1. + ztrcorb / ztrmasb
@@ -143,5 +134,5 @@
                END DO
             ENDIF
-
+            !
             IF( ztrcorn /= 0 ) THEN
                zcoef = 1. + ztrcorn / ztrmasn
@@ -157,21 +148,21 @@
                ztrtrdb(:,:,:) = ( ptrb(:,:,:,jn) - ztrtrdb(:,:,:) ) * zs2rdt
                ztrtrdn(:,:,:) = ( ptrn(:,:,:,jn) - ztrtrdn(:,:,:) ) * zs2rdt 
-               CALL trd_tra( kt, 'TRC', jn, jptra_trd_radb, ztrtrdb )       ! Asselin-like trend handling
-               CALL trd_tra( kt, 'TRC', jn, jptra_trd_radn, ztrtrdn )       ! standard     trend handling
+               CALL trd_tra( kt, 'TRC', jn, jptra_radb, ztrtrdb )       ! Asselin-like trend handling
+               CALL trd_tra( kt, 'TRC', jn, jptra_radn, ztrtrdn )       ! standard     trend handling
               !
             ENDIF
-
+            !
          END DO
          !
          !
       ELSE  ! total CFC content is not strictly preserved
-
+         !
          DO jn = jp_sms0, jp_sms1  
-
-           IF( l_trdtrc ) THEN
-              ztrtrdb(:,:,:) = ptrb(:,:,:,jn)                        ! save input trb for trend computation
-              ztrtrdn(:,:,:) = ptrn(:,:,:,jn)                        ! save input trn for trend computation
-           ENDIF
-
+            !
+            IF( l_trdtrc ) THEN
+               ztrtrdb(:,:,:) = ptrb(:,:,:,jn)                        ! save input trb for trend computation
+               ztrtrdn(:,:,:) = ptrn(:,:,:,jn)                        ! save input trn for trend computation
+            ENDIF
+            !
             DO jk = 1, jpkm1
                DO jj = 1, jpj
@@ -182,22 +173,21 @@
                END DO
             END DO
-         
-            IF( l_trdtrc ) THEN
-               !
+            !
+            IF( l_trdtrc ) THEN
                zs2rdt = 1. / ( 2. * rdt * FLOAT( nn_dttrc ) )
                ztrtrdb(:,:,:) = ( ptrb(:,:,:,jn) - ztrtrdb(:,:,:) ) * zs2rdt
                ztrtrdn(:,:,:) = ( ptrn(:,:,:,jn) - ztrtrdn(:,:,:) ) * zs2rdt 
-               CALL trd_tra( kt, 'TRC', jn, jptra_trd_radb, ztrtrdb )       ! Asselin-like trend handling
-               CALL trd_tra( kt, 'TRC', jn, jptra_trd_radn, ztrtrdn )       ! standard     trend handling
-              !
-            ENDIF
-            !
-         ENDDO
-
+               CALL trd_tra( kt, 'TRC', jn, jptra_radb, ztrtrdb )       ! Asselin-like trend handling
+               CALL trd_tra( kt, 'TRC', jn, jptra_radn, ztrtrdn )       ! standard     trend handling
+            ENDIF
+            !
+         END DO
+         !
       ENDIF
-
+      !
       IF( l_trdtrc )  CALL wrk_dealloc( jpi, jpj, jpk, ztrtrdb, ztrtrdn )
-
+      !
    END SUBROUTINE trc_rad_sms
+
 #else
    !!----------------------------------------------------------------------
Index: branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 3317)
+++ branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 3318)
@@ -4,9 +4,6 @@
    !! Ocean passive tracers:  surface boundary condition
    !!======================================================================
-   !! History :  8.2  !  1998-10  (G. Madec, G. Roullet, M. Imbard)  Original code
-   !!            8.2  !  2001-02  (D. Ludicone)  sea ice and free surface
-   !!            8.5  !  2002-06  (G. Madec)  F90: Free form and module
-   !!            9.0  !  2004-03  (C. Ethe)  adapted for passive tracers
-   !!                 !  2006-08  (C. Deltel) Diagnose ML trends for passive tracers
+   !! History :  1.0  !  2004-03  (C. Ethe)  adapt trasbc to passive tracers
+   !!            2.0  !  2006-08  (C. Deltel) Diagnose ML trends for passive tracers
    !!==============================================================================
 #if defined key_top
@@ -19,6 +16,6 @@
    USE trc             ! ocean  passive tracers variables
    USE prtctl_trc      ! Print control for debbuging
-   USE trdmod_oce
-   USE trdtra
+   USE trd_oce         ! trends: ocean variables
+   USE trdtra          ! trends: tracer manager
 
    IMPLICIT NONE
@@ -44,6 +41,5 @@
       !!       trend of tracer equations.
       !!
-      !! ** Method :
-      !!      * concentration/dilution effect:
+      !! ** Method :    concentration/dilution effect:
       !!            The surface freshwater flux modify the ocean volume
       !!         and thus the concentration of a tracer as :
@@ -55,14 +51,12 @@
       !! ** Action  : - Update the 1st level of tra with the trend associated
       !!                with the tracer surface boundary condition 
-      !!
       !!----------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !
-      INTEGER, INTENT( in ) ::   kt          ! ocean time-step index
-      !
-      INTEGER  ::   ji, jj, jn           ! dummy loop indices
+      INTEGER  ::   ji, jj, jn     ! dummy loop indices
       REAL(wp) ::   zsrau, zse3t   ! temporary scalars
-      CHARACTER (len=22) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zemps
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztrtrd
+      CHARACTER (len=22) ::   charout
+      REAL(wp), POINTER, DIMENSION(:,:  ) ::   zemps    ! 2D workspace
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztrtrd   ! 3D workspace
       !!---------------------------------------------------------------------
       !
@@ -108,5 +102,5 @@
          IF( l_trdtrc ) THEN
             ztrtrd(:,:,:) = tra(:,:,:,jn) - ztrtrd(:,:,:)
-            CALL trd_tra( kt, 'TRC', jn, jptra_trd_nsr, ztrtrd )
+            CALL trd_tra( kt, 'TRC', jn, jptra_nsr, ztrtrd )
          END IF
          !                                                       ! ===========
Index: branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 3317)
+++ branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 3318)
@@ -4,6 +4,6 @@
    !! Ocean Passive tracers : vertical diffusive trends 
    !!=====================================================================
-   !! History :  9.0  ! 2005-11 (G. Madec)  Original code
-   !!       NEMO 3.0  ! 2008-01  (C. Ethe, G. Madec)  merge TRC-TRA 
+   !! History :  1.0  ! 2005-11  (G. Madec)  Original code
+   !!            3.0  ! 2008-01  (C. Ethe, G. Madec)  merge TRC-TRA 
    !!----------------------------------------------------------------------
 #if defined key_top
@@ -14,18 +14,18 @@
    !!       ldf_ctl : initialization, namelist read, and parameters control
    !!----------------------------------------------------------------------
-   USE oce_trc         ! ocean dynamics and active tracers
-   USE trc             ! ocean passive tracers variables
-   USE trcnam_trp      ! passive tracers transport namelist variables
-   USE trazdf_exp      ! vertical diffusion: explicit (tra_zdf_exp     routine)
-   USE trazdf_imp      ! vertical diffusion: implicit (tra_zdf_imp     routine)
-   USE trdmod_oce
-   USE trdtra
-   USE prtctl_trc      ! Print control
+   USE oce_trc       ! ocean dynamics and active tracers
+   USE trc           ! ocean passive tracers variables
+   USE trcnam_trp    ! passive tracers transport namelist variables
+   USE trazdf_exp    ! vertical diffusion: explicit (tra_zdf_exp     routine)
+   USE trazdf_imp    ! vertical diffusion: implicit (tra_zdf_imp     routine)
+   USE trd_oce       ! trends: ocean variables
+   USE trdtra        ! trends: tracer manager
+   USE prtctl_trc    ! Print control
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   trc_zdf          ! called by step.F90 
-   PUBLIC   trc_zdf_alloc    ! called by nemogcm.F90 
+   PUBLIC   trc_zdf         ! called by step.F90 
+   PUBLIC   trc_zdf_alloc   ! called by nemogcm.F90 
 
    INTEGER ::   nzdf = 0               ! type vertical diffusion algorithm used
@@ -50,7 +50,5 @@
       !!----------------------------------------------------------------------
       ALLOCATE( r2dt(jpk) , STAT=trc_zdf_alloc )
-      !
       IF( trc_zdf_alloc /= 0 )   CALL ctl_warn('trc_zdf_alloc : failed to allocate array.')
-      !
    END FUNCTION trc_zdf_alloc
 
@@ -62,8 +60,8 @@
       !! ** Purpose :   compute the vertical ocean tracer physics.
       !!---------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::  kt      ! ocean time-step index
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !
-      INTEGER               ::  jk, jn
-      CHARACTER (len=22)    :: charout
+      INTEGER            ::  jk, jn
+      CHARACTER (len=22) :: charout
       REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   ztrtrd   ! 4D workspace
       !!---------------------------------------------------------------------
@@ -106,5 +104,5 @@
                ztrtrd(:,:,jk,jn) = ( ( tra(:,:,jk,jn) - trb(:,:,jk,jn) ) / r2dt(jk) ) - ztrtrd(:,:,jk,jn)
             END DO
-            CALL trd_tra( kt, 'TRC', jn, jptra_trd_zdf, ztrtrd(:,:,:,jn) )
+            CALL trd_tra( kt, 'TRC', jn, jptra_zdf, ztrtrd(:,:,:,jn) )
          END DO
          CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrtrd )
Index: branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90
===================================================================
--- branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 3317)
+++ branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 3318)
@@ -4,7 +4,7 @@
    !! Ocean diagnostics:  mixed layer passive tracer trends 
    !!======================================================================
-   !! History :  9.0  !  06-08  (C. Deltel)  Original code (from trdmld.F90)
-   !!                 !  07-04  (C. Deltel)  Bug fix : add trcrad trends
-   !!                 !  07-06  (C. Deltel)  key_gyre : do not call lbc_lnk
+   !! History :  1.0  !  2006-08  (C. Deltel)  Original code (from trdmld.F90)
+   !!             -   !  2007-04  (C. Deltel)  Bug fix : add trcrad trends
+   !!             -   !  2007-06  (C. Deltel)  key_gyre : do not call lbc_lnk
    !!----------------------------------------------------------------------
 #if   defined key_top && ( defined key_trdmld_trc   ||   defined key_esopa )
@@ -23,17 +23,18 @@
    USE zdfddm  , ONLY : avs  !: salinity vertical diffusivity coeff. at w-point
 # endif
+   USE trdmld_trc_rst    ! restart for diagnosing the ML trends
    USE trcnam_trp        ! passive tracers transport namelist variables
    USE trdmod_trc_oce    ! definition of main arrays used for trends computations
-   USE in_out_manager    ! I/O manager
    USE dianam            ! build the name of file (routine)
    USE ldfslp            ! iso-neutral slopes 
+   USE in_out_manager    ! I/O manager
    USE ioipsl            ! NetCDF library
    USE lbclnk            ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp           ! MPP library
-   USE trdmld_trc_rst    ! restart for diagnosing the ML trends
    USE prtctl            ! print control
    USE sms_pisces        ! PISCES bio-model
    USE sms_lobster       ! LOBSTER bio-model
-
+   USE wrk_nemo          ! Memory Allocation
+   
    IMPLICIT NONE
    PRIVATE
@@ -46,6 +47,6 @@
    PUBLIC trd_mld_bio_zint
 
-   CHARACTER (LEN=40) ::  clhstnam                                ! name of the trends NetCDF file
-   INTEGER ::   nmoymltrd
+   CHARACTER (LEN=40) ::   clhstnam                                ! name of the trends NetCDF file
+   INTEGER            ::   nmoymltrd
    INTEGER, ALLOCATABLE, SAVE, DIMENSION(:) ::   ndextrd1
    INTEGER, DIMENSION(jptra) ::   nidtrd, nh_t
@@ -61,10 +62,9 @@
 
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::  ztmltrd2   !
-#if defined key_lobster
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::  ztmltrdbio2  ! only needed for mean diagnostics in trd_mld_bio()
-#endif
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  ztmltrdbio2  ! only needed for mean diagnostics in trd_mld_bio()
 
    !! * Substitutions
 #  include "top_substitute.h90"
+#  include "zdfddm_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
@@ -367,28 +367,26 @@
       !!       In IV), the appropriate trends are written in the trends NetCDF file.
       !!
-      !! References :
-      !!       - Vialard & al.
-      !!       - See NEMO documentation (in preparation)
-      !!----------------------------------------------------------------------
-      !
+      !! References: Vialard et al., 2001, JPO.
+      !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !
-      INTEGER ::   ji, jj, jk, jl, ik, it, itmod, jn
-      REAL(wp) ::   zavt, zfn, zfn2
-      !
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltot             ! d(trc)/dt over the anlysis window (incl. Asselin)
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlres             ! residual = dh/dt entrainment term
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlatf             ! for storage only
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlrad             ! for storage only (for trb<0 corr in trcrad)
-      !
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltot2            ! -+
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlres2            !  | working arrays to diagnose the trends
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltrdm2           !  | associated with the time meaned ML
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlatf2            !  | passive tracers
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlrad2            !  | (-> for trb<0 corr in trcrad)
+      INTEGER ::   ji, jj, jk, jl      ! dummy loop indices
+      INTEGER ::   ik, it, itmod, jn   ! local integers
+      REAL(wp)::   zavt, zfn, zfn2    ! local scalars
+      !
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltot   ! d(trc)/dt over the anlysis window (incl. Asselin)
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlres   ! residual = dh/dt entrainment term
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlatf   ! for storage only
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlrad   ! for storage only (for trb<0 corr in trcrad)
+      !
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltot2   ! -+
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlres2   !  | working arrays to diagnose the trends
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmltrdm2  !  | associated with the time meaned ML
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlatf2   !  | passive tracers
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztmlrad2   !  | (-> for trb<0 corr in trcrad)
       !
       CHARACTER (LEN= 5) ::   clvar
 #if defined key_dimgout
-      INTEGER ::   iyear,imon,iday
+      INTEGER ::   iyear, imon, iday
       CHARACTER(LEN=80) ::   cltext, clmode
 #endif
Index: branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc.F90
===================================================================
--- branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc.F90	(revision 3317)
+++ branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/TOP_SRC/TRP/trdmod_trc.F90	(revision 3318)
@@ -11,12 +11,12 @@
    !!   'key_trdtrc'                      3D trend diagnostics
    !!----------------------------------------------------------------------
-   !!   trd_mod_trc      : passive tracer trends 
+   !!   trd_mod_trc   : passive tracer trends 
    !!----------------------------------------------------------------------
-   USE trc               ! tracer definitions (trn, trb, tra, etc.)
-   USE trcnam_trp
-   USE trdmod_oce
-   USE trdmod_trc_oce    ! definition of main arrays used for trends computations
-   USE trdmld_trc        ! Mixed layer trends diag.
-   USE iom               ! I/O library
+   USE trc            ! passive tracer variables
+   USE trcnam_trp     ! 
+   USE trd_oce        ! trends: ocean variables
+   USE trdmod_trc_oce ! definition of main arrays used for trends computations
+   USE trdmld_trc     ! Mixed layer trends diag.
+   USE iom            ! I/O library
 
    IMPLICIT NONE
@@ -24,8 +24,8 @@
 
    INTERFACE trd_mod_trc
-      MODULE PROCEDURE trd_mod_trc_trp, trd_mod_trc_bio
+      MODULE PROCEDURE   trd_mod_trc_trp, trd_mod_trc_bio
    END INTERFACE
 
-   PUBLIC trd_mod_trc
+   PUBLIC   trd_mod_trc   !
 
    !! * Substitutions
@@ -36,5 +36,4 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -43,8 +42,9 @@
       !!                  ***  ROUTINE trd_mod_trc  ***
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in )  ::   kt                                  ! time step
-      INTEGER, INTENT( in )  ::   kjn                                 ! tracer index
-      INTEGER, INTENT( in )  ::   ktrd                                ! tracer trend index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout )  ::   ptrtrd  ! Temperature or U trend
+      INTEGER                         , INTENT(in   ) ::   kt       ! time step
+      INTEGER                         , INTENT(in   ) ::   kjn      ! tracer index
+      INTEGER                         , INTENT(in   ) ::   ktrd     ! tracer trend index
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptrtrd   ! Temperature or U trend
+      !
       CHARACTER (len=20) :: cltra
       !!----------------------------------------------------------------------
@@ -62,21 +62,19 @@
          !
          SELECT CASE ( ktrd )
-         CASE ( jptra_trd_xad     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_xad, '3D', kjn )
-         CASE ( jptra_trd_yad     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_yad, '3D', kjn )
-         CASE ( jptra_trd_zad     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_zad, '3D', kjn )
-         CASE ( jptra_trd_ldf     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_ldf, '3D', kjn )
-         CASE ( jptra_trd_bbl     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_bbl, '3D', kjn )
-         CASE ( jptra_trd_zdf     )
-            IF( ln_trcldf_iso ) THEN
-               CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_ldf, '3D', kjn )
-            ELSE
-               CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_zdf, '3D', kjn )
+         CASE ( jptra_xad  )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_xad, '3D', kjn )
+         CASE ( jptra_yad  )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_yad, '3D', kjn )
+         CASE ( jptra_zad  )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_zad, '3D', kjn )
+         CASE ( jptra_ldf  )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_ldf, '3D', kjn )
+         CASE ( jptra_bbl  )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_bbl, '3D', kjn )
+         CASE ( jptra_zdf  )
+            IF( ln_trcldf_iso ) THEN   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_ldf, '3D', kjn )
+            ELSE                       ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_zdf, '3D', kjn )
             ENDIF
-         CASE ( jptra_trd_dmp     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_dmp , '3D', kjn )
-         CASE ( jptra_trd_nsr     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_sbc , '2D', kjn )
-         CASE ( jptra_trd_sms     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_sms , '3D', kjn )
-         CASE ( jptra_trd_radb    )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_radb, '3D', kjn )
-         CASE ( jptra_trd_radn    )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_radn, '3D', kjn )
-         CASE ( jptra_trd_atf     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_atf , '3D', kjn )
+         CASE ( jptra_dmp  )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_dmp , '3D', kjn )
+         CASE ( jptra_nsr  )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_sbc , '2D', kjn )
+         CASE ( jptra_sms  )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_sms , '3D', kjn )
+         CASE ( jptra_radb )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_radb, '3D', kjn )
+         CASE ( jptra_radn )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_radn, '3D', kjn )
+         CASE ( jptra_atf  )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_atf , '3D', kjn )
          END SELECT
          !
@@ -86,14 +84,15 @@
          !
          SELECT CASE( ktrd )
-         CASE( jptra_trd_xad )       ;    WRITE (cltra,'("XAD_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_yad )       ;    WRITE (cltra,'("YAD_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_zad )       ;    WRITE (cltra,'("ZAD_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_ldf )       ;    WRITE (cltra,'("LDF_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_bbl )       ;    WRITE (cltra,'("BBL_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_zdf )       ;    WRITE (cltra,'("ZDF_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_dmp )       ;    WRITE (cltra,'("DMP_",16a)')   ctrcnm(kjn)
-         CASE( jptra_trd_nsr )       ;    WRITE (cltra,'("FOR_",16a)')   ctrcnm(kjn)
+         CASE( jptra_xad  )   ;    WRITE (cltra,'("XAD_",16a)')   ctrcnm(kjn)
+         CASE( jptra_yad  )   ;    WRITE (cltra,'("YAD_",16a)')   ctrcnm(kjn)
+         CASE( jptra_zad  )   ;    WRITE (cltra,'("ZAD_",16a)')   ctrcnm(kjn)
+         CASE( jptra_ldf  )   ;    WRITE (cltra,'("LDF_",16a)')   ctrcnm(kjn)
+         CASE( jptra_bbl  )   ;    WRITE (cltra,'("BBL_",16a)')   ctrcnm(kjn)
+         CASE( jptra_zdf  )   ;    WRITE (cltra,'("ZDF_",16a)')   ctrcnm(kjn)
+         CASE( jptra_dmp  )   ;    WRITE (cltra,'("DMP_",16a)')   ctrcnm(kjn)
+         CASE( jptra_nsr  )   ;    WRITE (cltra,'("FOR_",16a)')   ctrcnm(kjn)
          END SELECT
-                                          CALL iom_put( cltra,  ptrtrd(:,:,:) )
+         !
+         CALL iom_put( cltra,  ptrtrd(:,:,:) )
          !
       END IF
@@ -101,28 +100,26 @@
    END SUBROUTINE trd_mod_trc_trp
 
+
    SUBROUTINE trd_mod_trc_bio( ptrbio, ktrd, kt )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE trd_mod_bio  ***
       !!----------------------------------------------------------------------
-
-      INTEGER, INTENT( in )  ::   kt                                  ! time step
-      INTEGER, INTENT( in )  ::   ktrd                                ! bio trend index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout )  ::   ptrbio  ! Bio trend
+      INTEGER                         , INTENT(in   )  ::   kt       ! time step
+      INTEGER                         , INTENT(in   )  ::   ktrd     ! bio trend index
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)  ::   ptrbio   ! Bio trend
       !!----------------------------------------------------------------------
-
-      CALL trd_mld_bio_zint( ptrbio, ktrd ) ! Verticaly integrated biological trends
-
+      !
+      CALL trd_mld_bio_zint( ptrbio, ktrd )       ! Verticaly integrated biological trends
+      !
    END SUBROUTINE trd_mod_trc_bio
+   
 #else
    !!----------------------------------------------------------------------
    !!   Default option :                                       Empty module
    !!----------------------------------------------------------------------
-
    INTERFACE trd_mod_trc
       MODULE PROCEDURE trd_mod_trc_trp, trd_mod_trc_bio
    END INTERFACE
-
 CONTAINS
-
    SUBROUTINE trd_mod_trc_trp( ptrtrd, kjn, ktrd, kt )
       INTEGER               , INTENT( in )     ::   kt      ! time step
